using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.TeamFoundation.WorkItemTracking.Client;

namespace SeriousTFSCustomization.WinUI
{
	public partial class LinkEditor : Form
	{
		public LinkEditor()
		{
			InitializeComponent();
		}

		private WorkItem m_fromWorkItem;
		public WorkItem FromWorkItem
		{
			get
			{
				return m_fromWorkItem;
			}
			set
			{
				m_fromWorkItem = value;
				m_labelFromWorkItem.Text = WorkItemWrapper.ToString(m_fromWorkItem);
			}
		}

		public void AddLinkTargetWorkItem(WorkItem item)
		{
			if (this.ToWorkItems.Contains(item) == false)
			{
				this.ToWorkItems.Add(item);
				m_listToWorkItems.Items.Add(new WorkItemWrapper(item));
			}
		}

		private List<WorkItem> m_toWorkItems;
		public List<WorkItem> ToWorkItems
		{
			get
			{
				if (m_toWorkItems == null) m_toWorkItems = new List<WorkItem>();

				return m_toWorkItems;
			}
		}
        
		public class WorkItemWrapper
		{
			public WorkItemWrapper(WorkItem item)
			{
				m_item = item;
			}

			private WorkItem m_item;
			public WorkItem Item
			{
				get
				{
					return m_item;
				}
				set
				{
					m_item = value;
				}
			}

			public override string ToString()
			{
				return ToString(this.Item);
			}

			public static string ToString(WorkItem item)
			{
				if (item == null)
				{
					return "(null)";
				}
				else
				{
					return String.Format("{0} ({1})", item.Title, item.Id);
				}
			}
		}

		private void m_btnSaveLinks_Click(object sender, EventArgs e)
		{
			try
			{
				foreach (WorkItem target in this.ToWorkItems)
				{
					FromWorkItem.Links.Add(new RelatedLink(target.Id));
				}

				this.FromWorkItem.Save();

				MessageBox.Show("Saved.");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			} 
		}
	}
}